﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using CPF.Drawing;

namespace SharpNes
{
    public class FastBitmap : IDisposable
    {
        public Bitmap Bitmap;
        public byte[] Bits;
        public bool Disposed;
        public int Height;
        public int Width;

        protected GCHandle BitsHandle { get; private set; }

        public FastBitmap(int width, int height)
        {
            Width = width;
            Height = height;
            Bits = new byte[width * height * 4];
            BitsHandle = GCHandle.Alloc(Bits, GCHandleType.Pinned);
            Bitmap = new Bitmap(width, height, width * 4, PixelFormat.PBgra, BitsHandle.AddrOfPinnedObject());

            for (int index = 3; index < Bits.Length; index += 4)
                Bits[index] = 0xFF;
        }

        public void Dispose()
        {
            if (Disposed) return;
            Disposed = true;
            Bitmap.Dispose();
            BitsHandle.Free();
        }
    }
}
